#include <bits/stdc++.h>

using namespace std;

int N,C,Q,a[200000],b[200000],cost[200000];
vector<bool>S,S_copy;
int s,s1;
string str;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>N>>C>>Q;
    cin>>str;
    for(char c: str){
        if(c=='0'){S.push_back(false);s--;}
        else{S.push_back(true);s++;}
    }
    for(int i=0;i<Q;i++){
        cin>>a[i]>>b[i];
        a[i]--;
        b[i]--;
    }

    for(int i=0;i<Q;i++){
        s1=s;
        for(int j=a[i];j<=b[i];j++){
            S[j]=not S[j];
            if(S[j]==false)s1-=2;
            else s1+=2;
        }
        S_copy=S;
        int stren=0;
        int spret;
        if(s1>0){
            for(int k=0;k<N;k++){
                if(S_copy[k]==0)S_copy[k]=1;
                else break;
            }
            for(int k=N-1;k>=0;k--){
                if(S_copy[k]==0)S_copy[k]=1;
                else break;
            }
            S_copy.flip();cost[i]+=C;
        }
        for(int k=0;k<N;k++){
            spret=stren;
            if(S_copy[k]==1){
                stren++;
            }
            if((k==N-1 || spret==stren) && stren!=0){
                if(C<stren)cost[i]+=C;
                else cost[i]+=stren;
                stren=0;
            }
        }
    }


    for(int i=0;i<Q;i++){cout<<cost[i]<<endl;}

}